/* menutool.cpp
 * Ovaj program ilustruje upotrebu rsursa menija, linije
 * sa altkama i objasnjenj alatki. Korisite meni, precicu
 * sa tastature ili paletu sa alatkama za menjanje boje.
 * Compatibility:Win95 i WinNT.
 */

#include <windows.h>
#include <commctrl.h>
#include "menutool.h"

#define NUMBUTTONS 3

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void DefToolbar();

char szProgName[] = "ProgName";
char szApplName[] = "Alteration";
static int iSize = 30;
static int iColor;

TBBUTTON TBButtons[NUMBUTTONS];
HWND hTBWnd;

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPreInst, LPSTR lpszCmdLine, int nCmdShow)
{
	HWND hWnd;
	HANDLE hAccel;
	MSG lpMsg;
	WNDCLASS wcApp;

	wcApp.lpszClassName = szProgName;
	wcApp.hInstance = hInst;
	wcApp.lpfnWndProc = WndProc;
	wcApp.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcApp.hIcon = NULL;
	wcApp.lpszMenuName = szApplName;
	wcApp.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcApp.style = CS_HREDRAW | CS_VREDRAW;
	wcApp.cbClsExtra = NULL;
	wcApp.cbWndExtra = NULL;

	if (RegisterClass(&wcApp))
		return 0;

	hWnd = CreateWindow(szProgName, "Meniji i alatke", WS_OVERLAPPEDWINDOW,
			0, 0, 640, 480, NULL, NULL, hInst, NULL);

	hAccel = LoadAccelerators(hInst, szApplName);

	DefToolbar();

	hTBWnd = CreateToolbarEx(hWnd, WS_VISIBLE | WS_CHILD | WS_BORDER | TBSTYLE_TOOLTIPS,
			IDTB_TOOLBAR, NUMBUTTONS, hInst, IDTB_BITMAP, TBButtons, NUMBUTTONS, 0, 0, 16, 16,
			sizeof(TBBUTTON));

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	while (GetMessage(&lpMsg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(hWnd, (HACCEL)hAccel, &lpMsg))
		{
			TranslateMessage(&lpMsg);
			DispatchMessage(&lpMsg);
		}
	}

	return (lpMsg.wParam);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT messg, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	LPTOOLTIPTEXT ToolTipStr;
	HMENU hmenu;
	static int xClientView, yClientView;
	static int iColorValue[3][3] = {	255, 0, 0, // Crveno
												0, 255, 0, // Zeleno
												0, 0, 255};// Plavo

	switch (messg)
	{
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDM_SMALL:
					iSize = 20;
					break;
				case IDM_MEDIUM:
					iSize = 50;
					break;
				case IDM_LARGE:
					iSize = 100;
					break;
				case IDM_RED:
				case IDM_GREEN:
				case IDM_BLUE:
					hmenu = GetMenu(hWnd);
					CheckMenuItem(hmenu, iColor, MF_UNCHECKED);
					iColor = LOWORD(wParam);
					CheckMenuItem(hmenu, iColor, MF_UNCHECKED);
					SetClassLong(hWnd, GCL_HBRBACKGROUND, (LONG)CreateSolidBrush(RGB(
							iColorValue[iColor - IDM_RED][0],
							iColorValue[iColor - IDM_RED][1],
							iColorValue[iColor - IDM_RED][2])));
					break;
				default:
					break;
			}

			InvalidateRect(hWnd, NULL, TRUE);
			break;
		case WM_SIZE:
			xClientView = LOWORD(lParam);
			yClientView = HIWORD(lParam);
			break;
		case WM_NOTIFY:
			ToolTipStr = (LPTOOLTIPTEXT)lParam;
			if (ToolTipStr->hdr.code == TTN_NEEDTEXT)
				switch (ToolTipStr->hdr.idFrom)
				{
					case IDM_RED:
						ToolTipStr->lpszText = "Crveno";
						break;
					case IDM_GREEN:
						ToolTipStr->lpszText = "Zeleno";
						break;
					case IDM_BLUE:
						ToolTipStr->lpszText = "Plavo";
						break;
				}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd,&ps);
			// ----- GDI funkcije za crtanje ispod -----

			SetMapMode(hdc, MM_ISOTROPIC);
			SetWindowExtEx(hdc, 500, 500, NULL);
			SetViewportExtEx(hdc, xClientView, -yClientView, NULL);
			SetViewportOrgEx(hdc, xClientView/2, yClientView/2, NULL);

			Ellipse(hdc, -(iSize*2), -iSize, iSize*2, iSize);
			TextOut(hdc, -(iSize/2), (iSize*2)+20, "Izmene", 6);

			ShowWindow(hTBWnd, SW_SHOW);
			UpdateWindow(hTBWnd);

			// ----- GDI funkcije za crtanje ispod -----
			ValidateRect(hWnd, NULL);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return (DefWindowProc(hWnd, messg, wParam, lParam));
	}

	return (0);
}

void DefToolbar()
{
	TBButtons[0].iBitmap = 0;
	TBButtons[0].idCommand = IDM_RED;
	TBButtons[0].fsState = TBSTATE_ENABLED;
	TBButtons[0].fsStyle = TBSTYLE_BUTTON;
	TBButtons[0].dwData = 0L;
	TBButtons[0].iString = 0;

	TBButtons[1].iBitmap = 1;
	TBButtons[1].idCommand = IDM_GREEN;
	TBButtons[1].fsState = TBSTATE_ENABLED;
	TBButtons[1].fsStyle = TBSTYLE_BUTTON;
	TBButtons[1].dwData = 0L;
	TBButtons[1].iString = 0;

	TBButtons[2].iBitmap = 2;
	TBButtons[2].idCommand = IDM_BLUE;
	TBButtons[2].fsState = TBSTATE_ENABLED;
	TBButtons[2].fsStyle = TBSTYLE_BUTTON;
	TBButtons[2].dwData = 0L;
	TBButtons[2].iString = 0;
}